

//*************************************************************************************************
//	   Adams-Bashforth-Moulton@(12)ɂ55P/Tempel-Tuttlea_Xĝm̐ϕvO(Adams5)
//     1866Noꂽ_Xg2001/11/18@ւ̉e
//       ver. 2.0   2015/06/13   by takesako@mrj.biglobe		
//*************************************************************************************************

//@̃vO͈ȉ̕/\[XQlɂĂ܂B
//@EuV̂̋OvZv꒘AV(1992)
//@@@т̃\tg/\[X@lbc(p290-p295)
//    @ (ϐ/z񖼓̂܂܎gĂ܂)
//@EuV(f/)̈ʒuZyї\̌vZ\tg/\[X mhodv@
//@@@(V3.21 1997/11/03)@by m[oX 
//@@@(Adams-Bashforth-Moulton@(12)NIPEڐA܂B)
//@Eup\RŌV̂̓vJHAGRqAnl(1992)
//  EuEXPLANATORY SUPPLEMENT to the ASTRONOMICAL ALMANACv
//@@@@U.S.NAVAL OBSERVATORY, UVLERSITY SCIENCE BOOKS(1992)
//@EuThe Planetary and Lunar Ephemerides DE430 and DE431v
//   @@William M. Folkner,* James G. Williams, Dale H. Boggs,
//	 @  Ryan S. Park, and Petr Kuchynka(2014/02/15)

//@̃vO̓e
//@ẼvO̐ۓ̑Ώۂ͑zEf(n܂)E11̂łB(M=0(z)`10())
//@EM=11͜a{́BM=12ȍ~_Xg
//@Ef͂̐ۓ͍lĂ܂B
//@ẼvO͂QXe[WŌvZ܂B
//      1stXe[WFvZ钼O܂ō݂̑傫ȃXebvŌvZ܂B(Ⴆ0.5)
//      2ndXe[WF҂鐔O琔ԊǔvZXebvŌvZ܂B(Ⴆ0.5)
//@E100܂ł̃_XgɑΉ邽߁AvOƂĂ͓ǂ݂ɂłz͊OϐƂĒ`Ă܂B 

#include <math.h>
#include <stdio.h>
#include "jpl_eph.h"
#include <time.h>

#define MULT(a,b) (a[1]*b[1]+a[2]*b[2]+a[3]*b[3]) // xNg̓όvZ̒`
#define DUST  20		  //_Xg̐̒`@ő100	
#define MAXN   (13+DUST)  //ϕV̐̒`:113max
#define MAX_NI MAXN       //ϕV̐Ɠ:113max
#define NIORD  12         //ϕ
#define NIDAY (NIORD+4)   //ϕ+[NGA
#define ADAMS  20         //ADAMŠWvZ鎟
#define NISTP  8          //ϕXebv@

//Tu[`̒`
void ni_Runge_Kutta_exec(FILE *fp_Bin,int NG,double DAY,double EPOCH,int NBODY);//QNb^@ɏlvZ[`
void ni_Adams_init( void );//	A_X̐lϕ@W̌vZ
void ni_Predict_Adams(double h,int p );//	A_X̐lϕ@(\)
void ni_Correct_Adams(double h,int p );//	A_X̐lϕ@(C)
int ni_Adams_exec(int NG, double t,double EPOCH,int p,int NBODY);	// return:̐ϕ[Ñ|C^[ 
void PERN(double EPOCH, int NG, int NBODY, int I);//x̌vZ(d͌ʕt)	
void NonGravity(int I, int M, double A1,double A2,double NGr[4]);// d͌ʂ̌vZ
void CDINI_file(FILE *fp_Bin, double *EPOCH ,int I, int NBODY,double StSpeed,double EndSpeed,double Step);//f[^̓ǂݍ
void DE_data(FILE *fp_Bin, double EPOCH ,int I );//z/f/̈ʒuExf[^DE431t@Cǂݍރ[`
void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude);
double JD(double year,double month,double day,double hour,int LST,double longitude);
double HourToHM(double Hour);
void duststar(int M);//t˓_̌vZ

double GMASS[MAXN],PER[NIDAY][MAXN][4],CD[NIDAY][MAXN][4],VL[NIDAY][MAXN][4], CD1[MAXN][MAXN], CD3[MAXN][MAXN];
    //     dʁ@@@@x@@@@@@@ʒu@@@@@@@@x@@@@@@@ V̊Ԃ̋@
	double AA[MAXN][4],VV[MAXN][4]; // ʒuƑx̃[NGA
	double MIN[MAXN][22];//n[aƓV̂̍Őڋߋ[M][0]Ɠ[M][1]i[
	double APcf[ADAMS], ACcf[ADAMS]; //adamšWi[
	int number;

//**MIN[MAXN][22]̓e***
//  MIN[M][ 0];Őڋߋ(AU)
//  MIN[M][ 1];ŐڋߓiEXʓj
//  MIN[M][ 2];ox(m/s)
//  MIN[M][ 3];
//  MIN[M][ 4];Õ_XgƂ̋(AU)@ŏ̌]
//  MIN[M][ 5];Õ_XgƂ̋(AU)
//	MIN[M][ 6]`MIN[M][ 8];//_Xg̈ʒu(zS)
//	MIN[M][ 9]`MIN[M][11];//_Xg̑x(zS)
//	MIN[M][12]`MIN[M][14];//n̈ʒu(zS)
//	MIN[M][15]`MIN[M][17];//n̑x(zS)
//	MIN[M][18]=Slam;zo()
//	MIN[M][19]=alph;t˓_()
//	MIN[M][20]=deg;t˓_()
//	MIN[M][21]=Vd;˓x(Km/s)

FILE  *fth,*optr,*ftp,*fp_Bin,*ttp;

void main(void)
{
	double EPOCH,DAY,TEPOCH;
	double	SFLDAY,B,DayMax,B1,B2,DAY1,DAY2,Jd1,Jd2;
	double year,month,day,hour, longitude=0.0,L1=0.0,L2=0.0;
	int 	I,M,N,NBODY;
	int LST=0, DE,NG,p;
	double StSpeed,EndSpeed,Step;
	time_t start_time,end_time,now;//Ԍvp萔
	
	start_time= time(&now);//sԌvJn

// JPL̈ʒu/xf[^t@CI[v
    DE=431; // DE431gp
	fp_Bin=INITIAL(DE);

//  vZʂރt@C(eLXg)I[v
	ftp= fopen ("data.csv","wt");
	fth= fopen ("TempleP55.csv","wt");

	NBODY=MAXN-1; // 0(MAXN-1)܂MAXN̔z𑀍삷̂Ɏgp

//	z̏;
	for ( M=0; M<=NBODY; M++){
		MIN[M][0]=1000.0;
		for ( N=1; N<=5; N++)MIN[M][N]=0.0;
		for ( N=0; N<=3; N++){
			for (I=0; I<=NIDAY-1; I++){
				PER   [I][M][N]=0.0;
				CD    [I][M][N]=0.0;
				VL    [I][M][N]=0.0;
				AA[M][N]       =0.0;
				VV[M][N]       =0.0;
			}
		}
	}

// 	vZ̕`B@+̏ꍇlOiB-͌ށB
	B1=+4;			//Xe[W̌vZԊu(8step)FB=+4̏ꍇ4/NISTEP(8)=0.5XebvŌvZB
	B2=+1.0/400.0;	//Xe[W̌vZԊu(8step)FB=+1.0/400.0̏ꍇ1/(400xNISTEP(8))=0.00031(0.45)XebvŌvZB
	
	StSpeed  =    13.7414;
	EndSpeed =    13.7415;

//	StSpeed  =   40.0;//vZŏ̃_Xg̕oXs[h(m/s)
//	EndSpeed =  -40.0;//vZŌ̃_Xg̕oXs[h(m/s)
	Step=(EndSpeed-StSpeed)/((double)NBODY-12.0);//_Xg̕oXs[h(m/s)̕ωԊu(m/s)

//	vZSTEP(Ԋu)̒`
	DAY1=B1/(double)NISTP;//Xe[W̌vZԊu(1step)
	DAY2=B2/(double)NISTP;//Xe[W̌vZԊu(1step)

//@vZ̊
	Jd1=JD(2001,11,10,0,0,0);//Xe[WI
	Jd2=JD(2001,11,20,0,0,0);//Xe[WI

//  ʕ\/t@Cւ̏݊Ԋu
	SFLDAY=365*10*100;

// 	d͌ʂ̌vZ̗L(NG=1)/(NG=0)
	NG=0;

//	_Xg̏l̐ݒ
	CDINI_file(fp_Bin, &EPOCH , 0, NBODY, StSpeed,EndSpeed,Step);

//	f/_Xg̏l̕\
	printf("\n");
	printf("@@lf[^@ jd=%12.3f\n",EPOCH);
	for( M=0; M<=NBODY; M++){
		printf(" CD[1] %2d %20.12f %20.12f %20.12f \n", M, CD[0][M][1], CD[0][M][2], CD[0][M][3]);
		printf(" VL[1] %2d %20.12f %20.12f %20.12f \n", M, VL[0][M][1], VL[0][M][2], VL[0][M][3]);
	}
	printf("\n");

// 	l̓tTEPOCHɊi[
	TEPOCH=EPOCH;
//@ǎ]
	number=0;
//	A_Xlϕ@@W̌vZ
	ni_Adams_init(  );

//*************************************Xe[W̌vZ**************************************************

//@lϕƂ͋t12Xebv(p=1`12)̒lQNb^ŌvZB
	ni_Runge_Kutta_exec( fp_Bin,NG,(-1.0)*DAY1, EPOCH, NBODY);//QNb^@ɂN̐ϕ̏ݒ胋[`

	// p (0`15)͔z(CD:ʒu,VL:x,PER:x)̌vZ|CgB
	p=0;

	while(1){

//	***  I(SFLDAY)Ƀt@Cɏރ[`***
	if(fmod((EPOCH-TEPOCH),SFLDAY) == 0.0 || EPOCH==2395203.5|| EPOCH==2397084.5|| EPOCH==2456994.5) {			
	Calendar(EPOCH,&year,&month,&day,&hour,LST,longitude);
	printf     ("EPOCH=%12.3f :  %5.0f/%2.0f/%2.0f\n",EPOCH,year,month,day);
	fprintf(ftp,"EPOCH=%12.3f :  %5.0f/%2.0f/%2.0f\n",EPOCH,year,month,day);
	for( M=0; M<=NBODY; M++){
		printf     (" %3d, %20.15f, %20.15f, %20.15f, \n",M, CD [p][M][1], CD [p][M][2], CD [p][M][3]);//ʒu
//		printf     (" %2d, %20.15f, %20.15f, %20.15f, \n",M, VL [p][M][1], VL [p][M][2], VL [p][M][3]);//x
//		printf     (" %2d, %20.15f, %20.15f, %20.15f, \n",M, PER[p][M][1], PER[p][M][2], PER[p][M][3]);//x
		fprintf(ftp," %3d, %20.15f, %20.15f, %20.15f, \n",M, CD [p][M][1], CD [p][M][2], CD [p][M][3]);//ʒu
//		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",M, VL [p][M][1], VL [p][M][2], VL [p][M][3]);//x
//		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",M, PER[p][M][1], PER[p][M][2], PER[p][M][3]);//x
		}
	}
//	***  I(SFLDAY)Ƀt@Cɏރ[`(܂) ***


	// 8STEP̒lAdams-Bashforth-Moulton@ŌvZB
	// ŏP=0ɏlAQNb^P=1`12܂ŋt12STEP̌vZlĂB
	// ŏp=0ni_Adams_exec()̌vZŁAP=15`P=88Xebv̌vZlP=8ŕԂĂB
	// @p=8ni_Adams_exec()̌vZŁAP= 7`P=08Xebv̌vZlP=0ŕԂĂB
	// ȍ~̌JԂB

	p=ni_Adams_exec( NG, B1,EPOCH, p, NBODY);	 

//	*** ɑz/f//fƂ̍Őڋߋ̋L^t@Cɏ ***

	L1=CD1[16][0]; // L1FŐṼn[Ezԋ L2:BŐ
	if(L1>2.0 && L2<2.0 ) // 2VPʗ鋫EŃf[^̕\/
	{
		number=number+1;
		Calendar( EPOCH, &year,&month,&day,&hour,0,0);
		printf("Position on %5.0f/%2.0f/%3.1f: JD= %.3f ; DE-%3d: Adams-Bashforth-Moulton, step= %8.5f day; L1=%5.2f, Rn=%3d\n", year,month,day,EPOCH,DE,DAY1,L1,number);
		printf(" No.   Vcomet   r          jd            date         fM        Distance\n");
		fprintf(fth,"Position on %5.0f/%2.0f/%3.1f: JD= %.3f ; DE-%3d: Adams-Bashforth-Moulton, step= %8.5f day; L1=%5.2f, Rn=%3d\n", year,month,day,EPOCH,DE,DAY1,L1,number);
		fprintf(fth," No.   Vcomet   r          jd            date         fM        Distance\n");
		for(M=11;M<=NBODY;M++){
		Calendar( MIN[M][1], &year,&month,&day,&hour,0,0);
		if(M==11){printf(             "%3d, %10.5f, %10.7f, , %10.3f, %5.0f/%2.0f/%2.0f,  0.00000,  0.00000\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day);
				fprintf(fth,          "%3d, %10.5f, %10.7f, , %10.3f, %5.0f/%2.0f/%2.0f,  0.00000,  0.00000\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day);

		}
		else{
		if(MIN[M][0]<0.10)printf(     "%3d, %10.5f, %10.7f,*, %10.3f, %5.0f/%2.0f/%2.0f, %8.5f, %8.5f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,MIN[M][4]/MIN[M][5],MIN[M][5]);
		 else printf(                 "%3d, %10.5f, %10.7f, , %10.3f, %5.0f/%2.0f/%2.0f, %8.5f, %8.5f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,MIN[M][4]/MIN[M][5],MIN[M][5]);
		if(MIN[M][0]<0.10)fprintf(fth,"%3d, %10.5f, %10.7f,*, %10.3f, %5.0f/%2.0f/%2.0f, %8.5f, %8.5f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,MIN[M][4]/MIN[M][5],MIN[M][5]);
		 else fprintf(fth,            "%3d, %10.5f, %10.7f, , %10.3f, %5.0f/%2.0f/%2.0f, %8.5f, %8.5f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,MIN[M][4]/MIN[M][5],MIN[M][5]);
		}
		}

		for(M=11;M<=NBODY;M++){
		MIN[M][0]=1000.0;
		MIN[M][1]=0.0;
		}
		L2=L1;
	}
	 else L2=L1;
//	*** ɑz/f//fƂ̍Őڋߋ̋L^t@Cɏ(܂) ***

//	+Bɐi
	EPOCH=EPOCH+B1;//BWSTEPŌvZĂB

// 	ȉ̏Ń[v𔲂
	if(EPOCH>Jd1) break;
	}


//*************************************Xe[W̌vZ**************************************************


		Calendar( EPOCH, &year,&month,&day,&hour,0,0);
		printf(     "\nStart 2nd Stage from %5.0f/%2.0f/%3.1f: JD= %.6f ; Adams-Bashforth-Moulton, step= %8.5f day; p=%d \n\n", year,month,day,EPOCH,DAY2,p);
		fprintf(fth,"\nStart 2nd Stage from %5.0f/%2.0f/%3.1f: JD= %.6f ; Adams-Bashforth-Moulton, step= %8.5f day; p=%d \n\n", year,month,day,EPOCH,DAY2,p);


// Xe[WŌvZŏIʂp=0ŖꍇɈʒuƑxp=0̈ʒuɏ
	if(p==8){
		for(M=11;M<=NBODY;M++){
		for(N=1;N<=3;N++){CD[0][M][N]=CD[8][M][N];VL[0][M][N]=VL[8][M][N]; }
		}	
	}

// EPOCHɂ鏉l̍Đݒ
	ni_Runge_Kutta_exec( fp_Bin,NG,(-1.0)*DAY2, EPOCH, NBODY);//QNb^@ɂN̐ϕ̏ݒ胋[`

	while(1){

	// 8STEP̒lAdams-Bashforth-Moulton@ŌvZB
	// ŏP=0ɏlAQNb^P=1`12܂ŋt12STEP̌vZlĂB
	// ŏp=0ni_Adams_exec()̌vZŁAP=15`P=88Xebv̌vZlP=8ŕԂĂB
	// @p=8ni_Adams_exec()̌vZŁAP= 7`P=08Xebv̌vZlP=0ŕԂĂB
	// ȍ~̌JԂB

	p=ni_Adams_exec( NG, B2,EPOCH, p, NBODY);	 
//	printf("EPOCH= %12.2f\n",EPOCH);

//	+Bɐi
	EPOCH=EPOCH+B2;//BWSTEPŌvZĂB

// 	ȉ̏Ń[v𔲂
	if(EPOCH>Jd2) break;
	}

//Xe[W̌vZʂ̏o
	{
//		number=number+1;
		Calendar( EPOCH, &year,&month,&day,&hour,0,0);
		printf("Position on %5.0f/%2.0f/%3.1f: JD= %.3f ; DE-%3d: Adams-Bashforth-Moulton, step= %8.5f day; L1=%5.2f, Rn=%3d\n", year,month,day,EPOCH,DE,DAY2,L1,number);
		printf(" No.   Vcomet   r          jd               date        HH.MM   fM        Distance Sun(long) RA       DEC      V(km/s)\n");
		fprintf(fth,"Position on %5.0f/%2.0f/%3.1f: JD= %.3f ; DE-%3d: Adams-Bashforth-Moulton, step= %8.5f day; L1=%5.2f, Rn=%3d\n", year,month,day,EPOCH,DE,DAY2,L1,number);
		fprintf(fth," No.   Vcomet   r          jd               date        HH.MM   fM        Distance Sun(long) RA       DEC      V(km/s)\n");
		for(M=11;M<=NBODY;M++){
		Calendar( MIN[M][1], &year,&month,&day,&hour,0,0);
		if(M==11){printf(             "%3d, %10.5f, %10.7f, , %12.6f, %5.0f/%2.0f/%2.0f,%6.2f,  0.00000,  0.00000\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,HourToHM(hour));
				fprintf(fth,          "%3d, %10.5f, %10.7f, , %12.6f, %5.0f/%2.0f/%2.0f,%6.2f,  0.00000,  0.00000\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,HourToHM(hour));

		}
		else{
		if(MIN[M][0]<0.10)printf(     "%3d, %10.5f, %10.7f,*, %12.6f, %5.0f/%2.0f/%2.0f,%6.2f, %8.5f, %8.5f,%8.2f,%8.2f,%8.2f,%8.2f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,HourToHM(hour),MIN[M][4]/MIN[M][5],MIN[M][5],MIN[M][18],MIN[M][19],MIN[M][20],MIN[M][21]);
		 else printf(                 "%3d, %10.5f, %10.7f, , %12.6f, %5.0f/%2.0f/%2.0f,%6.2f, %8.5f, %8.5f,%8.2f,%8.2f,%8.2f,%8.2f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,HourToHM(hour),MIN[M][4]/MIN[M][5],MIN[M][5],MIN[M][18],MIN[M][19],MIN[M][20],MIN[M][21]);
		if(MIN[M][0]<0.10)fprintf(fth,"%3d, %10.5f, %10.7f,*, %12.6f, %5.0f/%2.0f/%2.0f,%6.2f, %8.5f, %8.5f,%8.2f,%8.2f,%8.2f,%8.2f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,HourToHM(hour),MIN[M][4]/MIN[M][5],MIN[M][5],MIN[M][18],MIN[M][19],MIN[M][20],MIN[M][21]);
		 else fprintf(fth,            "%3d, %10.5f, %10.7f, , %12.6f, %5.0f/%2.0f/%2.0f,%6.2f, %8.5f, %8.5f,%8.2f,%8.2f,%8.2f,%8.2f\n",M,MIN[M][2],MIN[M][0],MIN[M][1],year,month,day,HourToHM(hour),MIN[M][4]/MIN[M][5],MIN[M][5],MIN[M][18],MIN[M][19],MIN[M][20],MIN[M][21]);
		}

//		printf (    "%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f\n",MIN[M][6],MIN[M][7],MIN[M][8],MIN[M][9],MIN[M][10],MIN[M][11],MIN[M][12],MIN[M][13],MIN[M][14],MIN[M][15],MIN[M][16],MIN[M][17]);	
//		fprintf(fth,"%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f\n",MIN[M][6],MIN[M][7],MIN[M][8],MIN[M][9],MIN[M][10],MIN[M][11],MIN[M][12],MIN[M][13],MIN[M][14],MIN[M][15],MIN[M][16],MIN[M][17]);	
		}


		for(M=11;M<=NBODY;M++){
		MIN[M][0]=1000.0;
		MIN[M][1]=0.0;
		}
//		L2=L1;
	}

	end_time= time(&now);//I
    printf("\n vOs [%d SEC] \n\n", end_time-start_time);//sԂ̕\
    fprintf(fth,"\n vOs [%d SEC] \n\n", end_time-start_time);//sԂ̕\

	//****************************************
	fclose(fp_Bin);
	fclose(ftp);
	fclose(fth);
}

//*********************************************************************
// QNb^@ɏlvZ[` (12step̌vZ)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************

void ni_Runge_Kutta_exec(FILE *fp_Bin,int NG,double DAY,double EPOCH,int NBODY)
{
	int i,k,n,I,p,M;
	double A,V;

//NBODY=16;

	/* f̏ʒǔvZ */
	for(i=0;i<NIORD;i++){
//		printf("f̏ʒu(%d)\n",i+1);
    I=i+0;  // lɂiڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I);
	
	for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+1][k][n]=VL[i+0][k][n]+PER[i+0][k][n]*DAY/2.0;
				CD[i+1][k][n]=CD[i+0][k][n]+VL[i+0][k][n]*DAY/2.0;
			}
		}

	I=i+1;  // lɂ2iڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I);

		for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+2][k][n]=VL[i+0][k][n]+PER[i+1][k][n]*DAY/2.0;
				CD[i+2][k][n]=CD[i+0][k][n]+VL[i+1][k][n]*DAY/2.0;
			}
		}
    I=i+2;  // lɂ3iڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I);

	for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+3][k][n]=VL[i+0][k][n]+PER[i+2][k][n]*DAY;
				CD[i+3][k][n]=CD[i+0][k][n]+VL[i+2][k][n]*DAY;
			}
		}
    I=i+3;  // lɂ3iڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I);

		for(k=11;k<MAX_NI;k++){ //f̂݉
			for(n=1;n<=3;n++){
				A =    PER[i+0][k][n];
				A+=2.0*PER[i+1][k][n];
				A+=2.0*PER[i+2][k][n];
				A+=    PER[i+3][k][n];
				A/=6.0;

				V =    VL[i+0][k][n];
				V+=2.0*VL[i+1][k][n];
				V+=2.0*VL[i+2][k][n];
				V+=    VL[i+3][k][n];
				V/=6.0;

				VL[i+1][k][n]=VL[i][k][n]+A*DAY;
				CD[i+1][k][n]=CD[i][k][n]+V*DAY;
			}
		}
	DE_data(fp_Bin, EPOCH+DAY*(double)(i+1) , i+1);//zEfEDE431t@Cǂݍ

}

    I=i+1;  // lɂiڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I);

	return;
}

//*********************************************************************
//	A_X̐lϕ@W̌vZ
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************

void ni_Adams_init(void )
{
	int i,j;

	// W̌vZ 
	APcf[0]=ACcf[0]=1.0;
	for(i=1;i<ADAMS;i++){
		APcf[i]=1.0;
		for(j=i;j>0;j--)APcf[i]-=APcf[j-1]/(double)(i-j+2);
		ACcf[i]=0.0;
		for(j=i;j>0;j--)ACcf[i]-=ACcf[j-1]/(double)(i-j+2);
	}
}

//*********************************************************************
//	A_X̐lϕ@(\)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
void ni_Predict_Adams(double h,int p)
{
	int j,k,m,n,M;
	double A,V;
	double Adif[NIORD][NIORD],Vdif[NIORD][NIORD];

	for(k=11;k<MAX_NI;k++){ //11ȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Adif[0][j]=PER[(p+j+1)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Adif[j][m]=Adif[j-1][m]-Adif[j-1][m+1];
			}
			A=0.0;
			for(j=0;j<NIORD;j++)A+=APcf[j]*Adif[j][0];
			VL[p][k][n]=VL[(p+1)%NIDAY][k][n]+A*h;
		}
	}
	for(k=11;k<MAX_NI;k++){ //11ȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Vdif[0][j]=VL[(p+j+1)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Vdif[j][m]=Vdif[j-1][m]-Vdif[j-1][m+1];
			}
			V=0.0;
			for(j=0;j<NIORD;j++)V+=APcf[j]*Vdif[j][0];
			CD[p][k][n]=CD[(p+1)%NIDAY][k][n]+V*h;
		}
	}
	return;
}

//*********************************************************************
//	A_X̐lϕ@(C)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
void ni_Correct_Adams(double h,int p)
{
	int j,k,m,n;
	double A,V;
	double Adif[NIORD][NIORD],Vdif[NIORD][NIORD];

	for(k=11;k<MAX_NI;k++){ //11ȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Adif[0][j]=PER[(p+j)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Adif[j][m]=Adif[j-1][m]-Adif[j-1][m+1];
			}
			A=0.0;
			for(j=0;j<NIORD;j++)A+=ACcf[j]*Adif[j][0];
			VL[p][k][n]=VL[(p+1)%NIDAY][k][n]+A*h;
		}
	}
	for(k=11;k<MAX_NI;k++){ //11ȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Vdif[0][j]=VL[(p+j)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Vdif[j][m]=Vdif[j-1][m]-Vdif[j-1][m+1];
			}
			V=0.0;
			for(j=0;j<NIORD;j++)V+=ACcf[j]*Vdif[j][0];
			CD[p][k][n]=CD[(p+1)%NIDAY][k][n]+V*h;
		}
	}
	return;
}

//*********************************************************************
//	A_X̐lϕ@^s
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
int ni_Adams_exec(int NG, double t,double EPOCH,int p,int NBODY)	// return:̐ϕ[Ñ|C^[ 
{
	int i,M,N;
	double h,dr;
	h=t/(double)NISTP;

	for(i=0;i<NISTP;i++){
		if(p>0)	p--;
		else	p=NIDAY-1;
		ni_Predict_Adams( h, p);
	    DE_data(fp_Bin, EPOCH+h*(double)(i+1) ,p);//zEfE͂cdt@Cǂݍ
		PERN ( EPOCH, NG, NBODY, p);
		ni_Correct_Adams( h, p);
	    DE_data(fp_Bin, EPOCH+h*(double)(i+1) ,p);//zEfE͂cdt@Cǂݍ
		PERN (  EPOCH, NG,NBODY, p);
		
	//efƂ̍ŐڋߋEtL^
		if(CD1[11][0]<MIN[11][0]){MIN[11][0]=CD1[11][0];MIN[11][1]=EPOCH+h*(double)(i+1);}// 11͜a{́BzƂ̍Őڋߋ/
			for ( M=12; M<=NBODY; M++){
			dr=CD1[M][0]-CD1[3][0];
			if(CD1[M][3]<fabs(MIN[M][0]) ){

			for(N=1;N<=3;N++){
				MIN[M][5+N]=CD[p][M][N]-CD[p][0][N];//_Xg̈ʒu(zS)
				MIN[M][8+N]=VL[p][M][N]-VL[p][0][N];//_Xg̑x(zS)
				MIN[M][11+N]=CD[p][3][N]-CD[p][0][N];//n̈ʒu(zS)
				MIN[M][14+N]=VL[p][3][N]-VL[p][0][N];//n̑x(zS)
				}
				duststar( M);

				if(dr>0)MIN[M][0]=CD1[M][3];
					else MIN[M][0]=-CD1[M][3];
				MIN[M][1]=EPOCH+h*(double)(i+1);
				MIN[M][3]=CD3[M][3];
				if(number==1){
					if( M==12)MIN[M][4]=CD1[M][M+1];
						else if( M==NBODY)MIN[M][4]=CD1[M][M-1];
						else MIN[M][4]=(CD1[M][M-1]+CD1[M][M+1])/2.0;
					MIN[M][5]= MIN[M][4];
					}
				else{
					if( M==12)MIN[M][5]=CD1[M][M+1];
						else if( M==NBODY)MIN[M][5]=CD1[M][M-1];
						else MIN[M][5]=(CD1[M][M-1]+CD1[M][M+1])/2.0;
					}
			}
		}// for M
	}
	return p;
}

//*********************************************************************
// fEf̏f[^̐ݒ
//*********************************************************************
void CDINI_file(FILE *fp_Bin, double *EPOCH ,int I, int NBODY,double StSpeed,double EndSpeed,double Step)
{
	int M,N;
	double GAUSS,GAUSS2,AMASS[MAXN];
	double BB[5][7];
	double SFLDAY,TC,TC2,AFLDAY,Va,Vc;
	int		IREC;

/*
// MPC 55P/Tempel-Tuttle  IAU Minor Planet Center WEB
//perihelion date 1866-01-11.6192 
// T(TPASS)      :2402613.11930000 :ߓ_ʉߎ
// (PERI/Somg) :170.89350000 :ߓ_
// (NODE/Omg)  :233.25280000 :_o
// i (INC)       :162.69020000 :OXΊp
// q (QDIS)      :  0.97653400 :ߓ_
// e (ECC)       :  0.90609200 :OS
// Px=   0.4696691 Py=   0.7901072 Pz=   0.3938802
// Qx=   0.8500415 Qy=  -0.2842340 Qz=  -0.4434416
*/

*EPOCH=2402613.5000;//adj=  0.00
CD[I][11][1]= 0.466414573827; CD[I][11][2]= 0.768948218348; CD[I][11][3]= 0.380571319800;
VL[I][11][1]= 0.020373174842; VL[I][11][2]=-0.006924200466; VL[I][11][3]=-0.010703558336;

/*
http://www.oaa.gr.jp/~oaacs/nk/nk722.htm
// T(TPASS)      :2366497.76471000 :ߓ_ʉߎ
// (PERI/Somg) :170.98044000 :ߓ_
// (NODE/Omg)  :232.91314000 :_o
// i (INC)       :162.82478000 :OXΊp
// q (QDIS)      :  0.97193140 :ߓ_
// e (ECC)       :  0.90630190 :OS
// Px=   0.4760853 Py=   0.7872995 Pz=   0.3917936
// Qx=   0.8472619 Qy=  -0.2913067 Qz=  -0.4441707
*/
/*
//[ T   = 1767 Feb. 24.26471 TT       Epoch =  1767 Feb.  7.0 TT
//Peri. = 170.98044                       e =    0.9063019
//Node  = 232.91314    (2000.0)           a =   10.3730087 AU
//Inc.  = 162.82478                       n'=    0.02950169
//    q =   0.9719314 AU                  P =   33.409 years    ]
// JD= 2366497.764710,  1767/ 2/24


*EPOCH=2366497.5000;//adj=  0.00
CD[I][11][1]= 0.457313862165; CD[I][11][2]= 0.767050215483; CD[I][11][3]= 0.383624790023;
VL[I][11][1]= 0.020450851445; VL[I][11][2]=-0.006952583885; VL[I][11][3]=-0.010668023449;

*/
Vc=sqrt(VL[I][11][1]*VL[I][11][1]+VL[I][11][2]*VL[I][11][2]+VL[I][11][3]*VL[I][11][3]);//PʃxNǧvZp
for(M=12;M<=NBODY;M++){
	Va=StSpeed+Step*(double)(M-12);
	MIN[M][2]=Va;
	for(N=1;N<=3;N++){CD[I][M][N]= CD[I][11][N];
	VL[I][M][N]=VL[I][11][N]+VL[I][11][N]/Vc*(Va* 24.0 * 3600.0/1.495978070e11);
	}
}
// 	jdɂ鑾z/f/̓ǂݍ
	DE_data(fp_Bin, *EPOCH, I);
// 	f/Əf̑zƂ̏dʔ`
	AMASS[ 0]=1.0/1.000000;			// Sun
	AMASS[ 1]=1.0/6023682.155592;	// Mercury
	AMASS[ 2]=1.0/408523.718658;	// Venus
	AMASS[ 3]=1.0/332946.048834;	// Earth
	AMASS[ 4]=1.0/3098703.590291;	// Mars
	AMASS[ 5]=1.0/1047.348625;		// Jupiter
	AMASS[ 6]=1.0/3497.901768;		// Saturn
	AMASS[ 7]=1.0/22902.981613;		// Uranus
	AMASS[ 8]=1.0/19412.259776;		// Neptune
	AMASS[ 9]=1.0/135836683.768617;	// Pluto
	AMASS[10]=1.0/27068703.241203;	// Moon


// aE_Xg̈ʒuEx𑾗znSɈړ
for(M=11;M<=NBODY;M++){
for(N=1;N<=3;N++){
		CD[I][M][N]=CD[I][M][N]+CD[I][0][N];
		VL[I][M][N]=VL[I][M][N]+VL[I][0][N];
}
AMASS[M]=0.0;
}

//	astronomical constants
	GAUSS =0.01720209895e0;
	GAUSS2=GAUSS*GAUSS;

//	planetary mass for DE431
	for ( M=0; M<= NBODY; M++){
		GMASS[M]=AMASS[M]*GAUSS2;
//		printf("%20.10E\n",GMASS[M]);
	}
}

//****************************************************************
// d͌ʂ̌vZ	(uV̋O_v@p329-330Q)
// A3iOʂɐj,B1/B2/B3(ԕω)͖(0)ƂB
//****************************************************************

	void NonGravity(int I, int M, double A1,double A2,double NGr[4])
{
	double x,y,z,vx,vy,vz,r,a,r0,m,n,k,Gr,F1,F2,vr,h;
		
	//V̂̈ʒu
	x=CD[I][M][1]; //V(M)̈ʒu
	y=CD[I][M][2];
	z=CD[I][M][3];
	vx=VL[I][M][1];//V(M)̑x
	vy=VL[I][M][2];
	vz=VL[I][M][3];
	r=CD1[0][M];   //z(0)ƓV(M)̋

	//g(r)=GřvZ
	a=0.111262; //
	r0=2.808;
	m=2.15;
	n=5.093;
	k=4.6142;
	Gr=a*pow(r/r0,-m)*pow(1.0+pow(r/r0,n),-k);
	//F1,F2W̌vZ
	F1=A1*1.0e-8*Gr;
	F2=A2*1.0e-8*Gr;
	
	vr=(x*vx+y*vy+z*vz)/r;
	h=sqrt(pow(y*vz-z*vy,2)+pow(z*vx-x*vz,2)+pow(x*vy-y*vx,2));

	//d͌
	NGr[1]=F1*x/r+F2*(r*vx-x*vr)/h;
	NGr[2]=F1*y/r+F2*(r*vy-y*vr)/h;
	NGr[3]=F1*z/r+F2*(r*vz-z*vr)/h;
}

//****************************************************************
// m̐ϕɂx̌vZ	
//****************************************************************
 	void PERN(double EPOCH, int NG, int NBODY, int I)
{
	double DIRECT[MAXN][MAXN][4],PER0[MAXN][4];
	double CDD[MAXN][MAXN][4],CD2[MAXN][MAXN],c;
	double U[MAXN][MAXN],SU[MAXN];
	double a10,a11,a12,a13,a14,a15,a16,a16_0,a17;
	double a20[4],a21[4],a22[4],a30[4];
	double NGr[4],A1,A2;
	int		i,j,N;	

	c=299792.458*24.0*3600.0/1.495978070e8; // Speed of Light (AU/DAY)


	for ( i=0; i<=NBODY; i++){
		for ( j=0; j<=NBODY; j++){
			if(i!=j){
				for(N=1;N<=3;N++)CDD[i][j][N]=CD[I][j][N]-CD[I][i][N];
				CD2[i][j]=MULT(CDD[i][j],CDD[i][j]);
				if(CD2[i][j]==0)CD2[i][j]=1e-32;
				CD1[i][j]=sqrt(CD2[i][j]);
				if(CD1[i][j]==0)CD1[i][j]=1e-32;
				U[i][j]=GMASS[j]/CD1[i][j];
				for(N=1;N<=3;N++)DIRECT[i][j][N]=CDD[i][j][N]*U[i][j]/CD2[i][j];
			}
		}
	}

	for ( i=0; i<=NBODY; i++){
		for ( j=0; j<=NBODY; j++){
			if(i!=j){
			CD3[i][j]=CDD[i][j][1]*CDD[i][j][2];
			}
		}
	}


for (i=0;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER0[i][N]=0.0;
			SU[i]=0.0;
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
				SU[i]=SU[i]+U[i][j];
				for(N=1;N<=3;N++)PER0[i][N]=PER0[i][N]+DIRECT[i][j][N];
				}
		}
	}
	


//		ʂ̉eꍇɎgp		
//		if(I==1){
//		for(i=0;i<=NBODY;i++){
//		for(j=0;j<=NBODY;j++){
//		printf("%2d %2d %15.12f %15.12f %12.12f\n",i,j,DIRECT[i][j][1],DIRECT[i][j][2],DIRECT[i][j][3]);
//		}
//		}
//		}


// j[g͊ŵݎgpꍇ(ΐ_xȍ~̓RgAEg)
// PER0[][][]̓j[g͊w̉x
//	for (i=0;i<=NBODY;i++){
//			for(N=1;N<=3;N++)PER[I][i][N]=0.0;
//			for( j=0;j<=NBODY;j++){ //0݂̂̏ꍇz͂̂
//			if(i  !=  j){
//				for(N=1;N<=3;N++)PER[I][i][N]=PER[I][i][N]+DIRECT[i][j][N];
//				}
//		}
//	}
//	return;

	
	// ΐ_x@P

		for (i=11;i<=NBODY;i++){
		for( j=0;j<=NBODY;j++){
			if(i  !=  j){
			a11=-4.0*SU[i];
			a12=-1.0*SU[j];
			a13= MULT(VL[I][i],VL[I][i]);
			a14= 2.0*MULT(VL[I][j],VL[I][j]);
			a15= -4.0* MULT(VL[I][i],VL[I][j]);
			a16_0=MULT(CDD[j][i],VL[I][j])/CD1[j][i];
			a16=-1.5*a16_0*a16_0;
			a17= 0.5* MULT(CDD[i][j],PER0[j]);
			a10=(1.0+(a11+a12+a13+a14+a15+a16+a17)/(c*c));
			for(N=1;N<=3;N++)DIRECT[i][j][N]=DIRECT[i][j][N]*a10;
			}
		}
		}
	
		for (i=11;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER[I][i][N]=0.0;
			for( j=0;j<=10;j++){
				if(i  !=  j){
				for(N=1;N<=3;N++)PER[I][i][N]=PER[I][i][N]+DIRECT[i][j][N];
				}
		}
	}

// ΐ_x@Q

		for (i=11;i<=NBODY;i++){
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
					for(N=1;N<=3;N++)a21[N]=(4.0*VL[I][i][N]-3.0*VL[I][j][N]);
					for(N=1;N<=3;N++){
						a22[N]=MULT(CDD[j][i],a21);
						a20[N]=U[i][j]/CD2[i][j]*a22[N]*(VL[I][i][N]-VL[I][j][N]);
						PER[I][i][N]=PER[I][i][N]+a20[N]/(c*c);
					}			
				}
		}
	}

// ΐ_x@R

		for (i=11;i<=NBODY;i++){
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
					for(N=1;N<=3;N++){
						a30[N]=3.5*U[i][j]*PER0[j][N];
						PER[I][i][N]=PER[I][i][N]+a30[N]/(c*c);
					}			
				}
		}
	}


// d͌ʂ̌vZ	(NG(NonGravity)tO"1"̏ꍇ)
	if(NG==1){	

		//55P/Tempel-Tuttle IAU Minor Planet Center WEB
        A1 =    -0.7976 ;//           +/- 0.0083
        A2 =    0.00901 ;//          +/- 0.000003

		for(i=11;i<=NBODY;i++){
		NonGravity( I, i , A1, A2, NGr);
		for(N=1;N<=3;N++)PER[I][i][N]=PER[I][i][N]+NGr[N];
		}	
	}
	
}

//*********************************************************************
// Qt˓_̌vZ[`
// (JYuV̋O_v355pageQ)
//*********************************************************************

void duststar(int M)
{
	double dpx,dpy,dpz,dvx,dvy,dvz,spx,spy,spz,svx,svy,svz;
	double dcx,dcy,dcz;
	double eps,Slam,alph,deg,Vd;
	double pi=3.1415926535897932/180.0;
//  _Xg̈ʒuEx
	dpx=MIN[M][ 6];	dpy=MIN[M][ 7];	dpz=MIN[M][ 8];
	dvx=MIN[M][ 9];	dvy=MIN[M][10];	dvz=MIN[M][11];
//@z̈ʒuEx(n̈ʒuEx̃}CiXl)
	spx=-MIN[M][12];	spy=-MIN[M][13];	spz=-MIN[M][14];
	svx=-MIN[M][15];	svy=-MIN[M][16];	svz=-MIN[M][17];

//	zǒvZ
	eps=atan(spz/spy);
	Slam=atan2(spy/cos(eps),spx)/pi;
	if(Slam<0 )Slam=Slam+360.0;

	dcx=-(dvx+svx);// = V*cos()*cos()
	dcy=-(dvy+svy);// = V*cos()*sin()
	dcz=-(dvz+svz);// = V*sin()

//	t˓_̌vZ
	alph=atan2(dcy,dcx)/pi; // FԌo
	if(alph<0 )alph=alph+360.0;

	deg=atan(dcz/(dcy/sin(alph*pi)))/pi;// FԈ

//	˓x(Km/s)̌vZ
	Vd=dcz/sin(deg*pi)*1731.5;

	MIN[M][18]=Slam;//zo()
	MIN[M][19]=alph;//t˓_Ԍo()
	MIN[M][20]=deg; //t˓_Ԉ()
	MIN[M][21]=Vd;  //˓x V (Km/s)

}

//*********************************************************************
// z/f/̈ʒuExf[^DE431t@Cǂݍރ[`
//*********************************************************************

void DE_data(FILE *fp_Bin, double EPOCH ,int I)
{

    int Planet, i;
	Position Eph;
  
//
//                 PLANET NUMBER                                           |
//                 1 = MERCURY         8 = NEPTUNE                         |
//                 2 = VENUS           9 = PLUTO                           |
//                 3 = EARTH          10 = MOON                            |
//                 4 = MARS           11 = SUN                             |
//                 5 = JUPITER                                             |
//                 6 = SATURN                                              |
//                 7 = URANUS                                              |
//

	 for(i=0;i<=10;i++){
	 Planet=i;
	 if(i==0)Planet=11;
	 Ephemerides( fp_Bin,EPOCH,Planet,&Eph);//SđznS̈ʒuǂݍ

//   ʒu
	 CD[I][i][1]=Eph.x;
	 CD[I][i][2]=Eph.y;
	 CD[I][i][3]=Eph.z;
//   x
	 VL[I][i][1]=Eph.vx;
	 VL[I][i][2]=Eph.vy;
	 VL[I][i][3]=Eph.vz;
	 }

}
/*******************************************************************************/
/*                      ̌vZ (JDt)                                */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/

void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude)
{
	double flag,Z,Alfa,A,B,C,D,E,F,Day0;
	
	flag = 1;

	if (longitude<0 ){
		longitude = - longitude;
		flag=-1.0;
	}
	
	if (LST==1) juday =  juday +  flag*(double)(int)(longitude /15.0+0.5)/24.0;
		else    juday =  juday +  flag*longitude /15.0/24.0	;
		
	juday = juday + 0.5;
	Z = (double)(int)(juday);
	F = juday - Z;

	if (Z < 2299161.0) A = Z;
		else { 
			Alfa = (double)(int) ((Z - 1867216.25)/36524.25);
			A = Z + 1 + Alfa - (double)(int) (Alfa/4.0);}

	B = A + 1524;
	C = (double)(int) ((B-122.1)/365.25);
	D = (double)(int) (365.25 * C);
	E = (double)(int) ((B-D)/30.6001);

	Day0 = B - D - (double)(int)(30.60001*E) + F;
	*day = (double)(int)(Day0);
	*hour= F*24.0;
	if(E<14.0) *month = E-1.0;
	if(E==14.0 || E==15.0)	 *month = E- 13.0;
	if(*month>2.0) *year=C-4716;
	if(*month==1.0 || *month==2.0) *year = C - 4715;
}

/*******************************************************************************/
/*                      ̌vZ (tJD)                                */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/


// Tested from jd=-100000000 to jd=100000000// 2015/03/21
double JD(double year,double month,double day,double hour,int LST,double longitude)
{
	double s,juday,a,flag;

	flag =1;
	if (longitude <0){ 
		longitude = -longitude;
		flag=-1;
		}

	if ( month < 3 ){
		year = year -1;
		month = month +12;
		};
	s = floor( 365.25 * year) + floor( 30.59 * (month-2.0));
	if (LST==1)
	{juday = s + day + hour/24.0 -  flag*floor(longitude /15.0+0.5)/24.0	+ 1721086.5;}
		else
		{juday = s + day + hour/24.0 -  flag*longitude /15.0/24.0	+ 1721086.5;}

	if ( juday > 2299161 ) {
		a = floor ( year / 400 ) - floor( year / 100)+2;
		juday = juday + a;
		};

	return(juday);

}

/*******************************************************************************/
/*                      ԕ\玞ԕb\ւ̕ϊ        */
/*******************************************************************************/
double HourToHM(double Hour)

{
	double Min,H;
	
	H=(double)(int)Hour;
	Min   = (Hour - H)*60.0;
	H     = H +  Min/100.0 ;
    return H;
}


